/*
 * Configuration for SKKFEP
 */

#include "configs/solaris2.h"

#if makefile_parameter
CC=gcc
DEFINE=-DUSE_LOCALE
OPTIMIZE=-O
EXTRALIBS=
#endif

#define NUMCONV		/* enable numeric conversion feature */
#define REGMODE		/* enable register mode feature */
#define USE_SKKSRCH	/* use skksrch.c instead of skkserv */
#define BOTH_SERVER_AND_SKKSRCH	/* use skksrch.c if failed to connect skkserv*/
#define USE_TRIANGLE	/* use triangle mark like SKK */
/*#define SKKFEP_LIB	/* use skkfep as library for SKK interface on jvim */

#define DEFAULT_KANAKEY "^j"

/* By Y. Kaneko */
/*#define KUTOUTEN        /* "."->maru, ","->ten */
/*#define MORE_ASCII	/* insert "?!:;" in ASCII instead of KANJI(ZENKAKU) */

#ifndef SKKFEP_LIB
#define KANJIBS			/* do/don't shuft-out BS code in JIS mode */
#define KANJIBS_DEFAULT	0	/* 0 -> shift out / 1 -> don't shift out  */
/*#define FEPCTRLSEQ		/* do FEP on/off by ESC sequence */
/*#define FEPCTRLSEQ_DEFAULT 0	/* 0 -> don't use fep control sequence */
#endif /* SKKFEP_LIB */
#define PRESERVE_ON_FAILURE 1	/* preserve candidate on conversion failure */

#if defined MSDOS && !defined WIN32
# ifdef BOTH_SERVER_AND_SKKSRCH
#  undef BOTH_SERVER_AND_SKKSRCH  /* not support to connect skkserv on DOS */
#  define USE_SKKSRCH
# endif
#define NET_LEARN_MODE LearnOff		/* on MS-DOS memory is not enough */
#define USER_DIC_NAME "_skk-jisyo"
#else
#define NET_LEARN_MODE LearnPermanent	/* Write back words obtained from */
					/* SKK server			  */

#define USER_DIC_NAME ".skk-jisyo"
#endif
/* #define SYSTEM_DIC_NAME "/usr/local/emacs/etc/SKK-JISYO.L" */

#define NATIVECODE	euc	/* EUC Kanji code */

#define SKK_SERVER_HOST	"localhost"	/* SKK server host */

#ifdef BOTH_SERVER_AND_SKKSRCH
# define USE_SERVER
# define USE_SKKSRCH
#endif

#ifdef USE_SKKSRCH
# define SKKSRCH_DIC		"/usr/local/share/skk/SKK-JISYO.L"
# define BINARY_SEARCH			/* do binary search in skksrch.c */
# define USE_SERVER
# ifndef BOTH_SERVER_AND_SKKSRCH
#  define openSKKserv		openSKKsrch
#  define closeSKKserv		closeSKKsrch
#  define getCandFromServer	getCandFromSKKsrch
# endif	/* BOTH_SERVER_AND_SKKSRCH */
#endif

#ifdef SKKFEP_LIB
/* for jvim2.0r: Do not define MOVE_CURSOR. jpfep.c uses buffer.
 * for vim3+j1.3d: define MOVE_CURSOR to use cursor move sequence on conversion
 */
# define MOVE_CURSOR
# define USERDIC_CHANGED_CHECK /* check UserDic change to save only when need*/
# define USE_TRIANGLE	/* use SKK's triangle mark */
# define showmode	showSKKmode
#endif
