#include "config.h"
#include <stdio.h>
#include <sys/types.h>
#include "skklib.h"
#ifdef MSDOS
# include <stdlib.h>	/* for getenv() */
#endif

int ServerOK;

main() 
{
	Dictionary dic;
	char dicname[64];
	DicList dl,prevdl;
	CandList dcand,scand;
	char *home;

	if ((home = getenv("HOME")) == NULL) {
		fprintf(stderr,"Can't get home directory from getenv(\"HOME\").\n");
		exit(1);
	}
	sprintf(dicname,"%s/%s",home,USER_DIC_NAME);
#ifndef MSDOS
	dic = openSKK(dicname);
	if (dic == NULL) {
		fprintf(stderr,"Can't open user dictionary %s\n",dicname);
		exit(1);
	}
#endif

	if (openSKKserv() < 0) {
		fprintf(stderr, "Can't open SKK server\n");
		exit(1);
	}

#ifdef MSDOS
	/* on MS-DOS, may not be able to read whole UserDic
	 * because of memory limitation.
	 * so in every turn, read one line and check candidates in that line.
	 */
	{
	FILE *f;
	char buf[512];
	char *p,c;
	int i;
	int okuriAri = 1;

	if ((f = fopen(dicname,"rb")) == NULL) {
		fprintf(stderr, "Can't open dictionary file: %s\n", dicname);
		return -1;
	}
	while (!feof(f)) {
		while ((c = fgetc(f)) == ' ' || c == '\t' || c == '\n');
		if (feof(f)) break;
		if (c == ';') {	/* comment */
			i = 0;
			while (c != '\n' && !feof(f)) {
				c = fgetc(f);
				buf[i++] = c;
			}
			buf[i] = '\0';
			if (!strncmp(buf,"; okuri-ari entries.",20)) {
				okuriAri = 1;
				fprintf(stdout,";; okuri-ari entries.\n");
			}
			else if (!strncmp(buf,"; okuri-nasi entries.",21)) {
				okuriAri = 0;
				fprintf(stdout,";; okuri-nasi entries.\n");
			}
			continue;
		}
		for (buf[0] = c, p = buf+1; 
		     !feof(f) && (*p = fgetc(f)) != ' '; 
		     p++) {
		}
		*p = '\0';
		if ((dcand = getCandList(f,NULL,okuriAri)) == NULL) {
			fprintf(stderr, "failed getCandList() for %s.\n", buf);
			fclose(f);
			return -1;
		}
		/* check in server dictionary */
		scand = getCandFromServer(buf);
		dcand = deleteCand(dcand,scand);
		if (dcand != NULL) {
			fprintf(stdout,"%s ",buf);
			printCand(dcand,stdout,1);
		}
		if (scand != NULL)
			freeCand(scand);
	}
	fclose(f);
	}
#else
	prevdl = NULL;
	for (dl = dic->dlist; dl != NULL; dl = dl->nextitem) {
		dcand = dl->cand;
		scand = getCandFromServer(dl->kanaword);
		dl->cand = deleteCand(dcand,scand);
		if (dl->cand == NULL) {
			if (dl == dic->dlist)
				dic->dlist = dl->nextitem;
			else
				prevdl->nextitem = dl->nextitem;
		}
		else
			prevdl = dl;
	}

	closeSKK(dic,dicname);
	closeSKKserv();
#endif

	return 0;
}
